<iframe src="../.ibox.html?raw=true" style="border:none; position:fixed; width:40px; right:0; z-index=999;"></iframe>

# REPL

A REPL (Read Evaluate Print Loop) session is an interactive workspace in which to use ogma.

![](../assets/repl-1.gif?raw=true)

The REPL is an excellent place to test out expressions and definitions.
Use `def --list` to view the commands available.

_Hint: When starting out you might want to keep referring to the available definitions.
To save a copy of the definition list, use `def --list | save ogma-defs.csv`._

_Hint: To add a new line in the REPL, use `Alt+Return`._

## `cd` - Change working directory
---
The command `cd` changes the working directory by navigating to the path specfied. For
instance, if one is working at the root level, then uses `cd foo`, the REPL will navigate
to the folder `foo` (if it exists). The prompt also changes to reflect the working
directory. To navigate **up** a level, use `..`.

## `run` - Run an `ogma` batch file
---
The command `run` takes a file path pointed to an _`ogma` batch file_. The file is simply
multiple expressions _and_ definitions that get processed in a _batch_. 
The chapter [Batch Files](../09%20Batch%20Files.md?book=true) documents batch files further.

Each item (whether an expression of definition) can use comments by way of the pound (`#`)
character _before_ the item. **_Each item is separated by a least one blank line._**

When processing the items, each definition is processed _first_ (in order) in a sequential
manner. Expressions are processed after in _a parallel_ order. If an error is encountered,
the processing stops. `run` accepts two flags:

- `--no-par`: This turns off parallelisation and processes items in order.
- `--no-fail-fast`: This continues processing if an error is encountered.

The idea of a batch file is to do processing on data which transforms the data into more
representable formats. The use of `save` is recommended (see `save ---help`).
